class File():
    def __init__(self, values = []):
        self.__values = []
        for v in values:
            self.ajoute(v)

    def ajoute(self, v):
        self.__values.append(v)
        return v

    def supprime(self):
        v = self.__values.pop(0)
        return v

    def renvoie(self, critere = lambda x : True):
        for v in self.__values:
            if critere(v):
                return v
        return False

    def affiche(self):
        for v in self.__values:
            print(v)

    def taille(self): 
        return len(self.__values)

if __name__ == "__main__":
    f = File()
    for d in [1, 2, 3]:
        f.ajoute(d)
